// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_sensor_msgs:srv/SetExposure.idl
// generated code does not contain a copyright notice
#include "marti_sensor_msgs/srv/detail/set_exposure__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
marti_sensor_msgs__srv__SetExposure_Request__init(marti_sensor_msgs__srv__SetExposure_Request * msg)
{
  if (!msg) {
    return false;
  }
  // auto_exposure
  // time
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Request__fini(marti_sensor_msgs__srv__SetExposure_Request * msg)
{
  if (!msg) {
    return;
  }
  // auto_exposure
  // time
}

bool
marti_sensor_msgs__srv__SetExposure_Request__are_equal(const marti_sensor_msgs__srv__SetExposure_Request * lhs, const marti_sensor_msgs__srv__SetExposure_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // auto_exposure
  if (lhs->auto_exposure != rhs->auto_exposure) {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Request__copy(
  const marti_sensor_msgs__srv__SetExposure_Request * input,
  marti_sensor_msgs__srv__SetExposure_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // auto_exposure
  output->auto_exposure = input->auto_exposure;
  // time
  output->time = input->time;
  return true;
}

marti_sensor_msgs__srv__SetExposure_Request *
marti_sensor_msgs__srv__SetExposure_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Request * msg = (marti_sensor_msgs__srv__SetExposure_Request *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_sensor_msgs__srv__SetExposure_Request));
  bool success = marti_sensor_msgs__srv__SetExposure_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_sensor_msgs__srv__SetExposure_Request__destroy(marti_sensor_msgs__srv__SetExposure_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_sensor_msgs__srv__SetExposure_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_sensor_msgs__srv__SetExposure_Request__Sequence__init(marti_sensor_msgs__srv__SetExposure_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Request * data = NULL;

  if (size) {
    data = (marti_sensor_msgs__srv__SetExposure_Request *)allocator.zero_allocate(size, sizeof(marti_sensor_msgs__srv__SetExposure_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_sensor_msgs__srv__SetExposure_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_sensor_msgs__srv__SetExposure_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Request__Sequence__fini(marti_sensor_msgs__srv__SetExposure_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_sensor_msgs__srv__SetExposure_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_sensor_msgs__srv__SetExposure_Request__Sequence *
marti_sensor_msgs__srv__SetExposure_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Request__Sequence * array = (marti_sensor_msgs__srv__SetExposure_Request__Sequence *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_sensor_msgs__srv__SetExposure_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_sensor_msgs__srv__SetExposure_Request__Sequence__destroy(marti_sensor_msgs__srv__SetExposure_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_sensor_msgs__srv__SetExposure_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marti_sensor_msgs__srv__SetExposure_Request__Sequence__are_equal(const marti_sensor_msgs__srv__SetExposure_Request__Sequence * lhs, const marti_sensor_msgs__srv__SetExposure_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Request__Sequence__copy(
  const marti_sensor_msgs__srv__SetExposure_Request__Sequence * input,
  marti_sensor_msgs__srv__SetExposure_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_sensor_msgs__srv__SetExposure_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marti_sensor_msgs__srv__SetExposure_Request * data =
      (marti_sensor_msgs__srv__SetExposure_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_sensor_msgs__srv__SetExposure_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marti_sensor_msgs__srv__SetExposure_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
marti_sensor_msgs__srv__SetExposure_Response__init(marti_sensor_msgs__srv__SetExposure_Response * msg)
{
  if (!msg) {
    return false;
  }
  // auto_exposure
  // time
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Response__fini(marti_sensor_msgs__srv__SetExposure_Response * msg)
{
  if (!msg) {
    return;
  }
  // auto_exposure
  // time
}

bool
marti_sensor_msgs__srv__SetExposure_Response__are_equal(const marti_sensor_msgs__srv__SetExposure_Response * lhs, const marti_sensor_msgs__srv__SetExposure_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // auto_exposure
  if (lhs->auto_exposure != rhs->auto_exposure) {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Response__copy(
  const marti_sensor_msgs__srv__SetExposure_Response * input,
  marti_sensor_msgs__srv__SetExposure_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // auto_exposure
  output->auto_exposure = input->auto_exposure;
  // time
  output->time = input->time;
  return true;
}

marti_sensor_msgs__srv__SetExposure_Response *
marti_sensor_msgs__srv__SetExposure_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Response * msg = (marti_sensor_msgs__srv__SetExposure_Response *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_sensor_msgs__srv__SetExposure_Response));
  bool success = marti_sensor_msgs__srv__SetExposure_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_sensor_msgs__srv__SetExposure_Response__destroy(marti_sensor_msgs__srv__SetExposure_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_sensor_msgs__srv__SetExposure_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_sensor_msgs__srv__SetExposure_Response__Sequence__init(marti_sensor_msgs__srv__SetExposure_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Response * data = NULL;

  if (size) {
    data = (marti_sensor_msgs__srv__SetExposure_Response *)allocator.zero_allocate(size, sizeof(marti_sensor_msgs__srv__SetExposure_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_sensor_msgs__srv__SetExposure_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_sensor_msgs__srv__SetExposure_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Response__Sequence__fini(marti_sensor_msgs__srv__SetExposure_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_sensor_msgs__srv__SetExposure_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_sensor_msgs__srv__SetExposure_Response__Sequence *
marti_sensor_msgs__srv__SetExposure_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Response__Sequence * array = (marti_sensor_msgs__srv__SetExposure_Response__Sequence *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_sensor_msgs__srv__SetExposure_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_sensor_msgs__srv__SetExposure_Response__Sequence__destroy(marti_sensor_msgs__srv__SetExposure_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_sensor_msgs__srv__SetExposure_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marti_sensor_msgs__srv__SetExposure_Response__Sequence__are_equal(const marti_sensor_msgs__srv__SetExposure_Response__Sequence * lhs, const marti_sensor_msgs__srv__SetExposure_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Response__Sequence__copy(
  const marti_sensor_msgs__srv__SetExposure_Response__Sequence * input,
  marti_sensor_msgs__srv__SetExposure_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_sensor_msgs__srv__SetExposure_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marti_sensor_msgs__srv__SetExposure_Response * data =
      (marti_sensor_msgs__srv__SetExposure_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_sensor_msgs__srv__SetExposure_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marti_sensor_msgs__srv__SetExposure_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "marti_sensor_msgs/srv/detail/set_exposure__functions.h"

bool
marti_sensor_msgs__srv__SetExposure_Event__init(marti_sensor_msgs__srv__SetExposure_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    marti_sensor_msgs__srv__SetExposure_Event__fini(msg);
    return false;
  }
  // request
  if (!marti_sensor_msgs__srv__SetExposure_Request__Sequence__init(&msg->request, 0)) {
    marti_sensor_msgs__srv__SetExposure_Event__fini(msg);
    return false;
  }
  // response
  if (!marti_sensor_msgs__srv__SetExposure_Response__Sequence__init(&msg->response, 0)) {
    marti_sensor_msgs__srv__SetExposure_Event__fini(msg);
    return false;
  }
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Event__fini(marti_sensor_msgs__srv__SetExposure_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  marti_sensor_msgs__srv__SetExposure_Request__Sequence__fini(&msg->request);
  // response
  marti_sensor_msgs__srv__SetExposure_Response__Sequence__fini(&msg->response);
}

bool
marti_sensor_msgs__srv__SetExposure_Event__are_equal(const marti_sensor_msgs__srv__SetExposure_Event * lhs, const marti_sensor_msgs__srv__SetExposure_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!marti_sensor_msgs__srv__SetExposure_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!marti_sensor_msgs__srv__SetExposure_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Event__copy(
  const marti_sensor_msgs__srv__SetExposure_Event * input,
  marti_sensor_msgs__srv__SetExposure_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!marti_sensor_msgs__srv__SetExposure_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!marti_sensor_msgs__srv__SetExposure_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

marti_sensor_msgs__srv__SetExposure_Event *
marti_sensor_msgs__srv__SetExposure_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Event * msg = (marti_sensor_msgs__srv__SetExposure_Event *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_sensor_msgs__srv__SetExposure_Event));
  bool success = marti_sensor_msgs__srv__SetExposure_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_sensor_msgs__srv__SetExposure_Event__destroy(marti_sensor_msgs__srv__SetExposure_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_sensor_msgs__srv__SetExposure_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_sensor_msgs__srv__SetExposure_Event__Sequence__init(marti_sensor_msgs__srv__SetExposure_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Event * data = NULL;

  if (size) {
    data = (marti_sensor_msgs__srv__SetExposure_Event *)allocator.zero_allocate(size, sizeof(marti_sensor_msgs__srv__SetExposure_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_sensor_msgs__srv__SetExposure_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_sensor_msgs__srv__SetExposure_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_sensor_msgs__srv__SetExposure_Event__Sequence__fini(marti_sensor_msgs__srv__SetExposure_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_sensor_msgs__srv__SetExposure_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_sensor_msgs__srv__SetExposure_Event__Sequence *
marti_sensor_msgs__srv__SetExposure_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_sensor_msgs__srv__SetExposure_Event__Sequence * array = (marti_sensor_msgs__srv__SetExposure_Event__Sequence *)allocator.allocate(sizeof(marti_sensor_msgs__srv__SetExposure_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_sensor_msgs__srv__SetExposure_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_sensor_msgs__srv__SetExposure_Event__Sequence__destroy(marti_sensor_msgs__srv__SetExposure_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_sensor_msgs__srv__SetExposure_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marti_sensor_msgs__srv__SetExposure_Event__Sequence__are_equal(const marti_sensor_msgs__srv__SetExposure_Event__Sequence * lhs, const marti_sensor_msgs__srv__SetExposure_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_sensor_msgs__srv__SetExposure_Event__Sequence__copy(
  const marti_sensor_msgs__srv__SetExposure_Event__Sequence * input,
  marti_sensor_msgs__srv__SetExposure_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_sensor_msgs__srv__SetExposure_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marti_sensor_msgs__srv__SetExposure_Event * data =
      (marti_sensor_msgs__srv__SetExposure_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_sensor_msgs__srv__SetExposure_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marti_sensor_msgs__srv__SetExposure_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_sensor_msgs__srv__SetExposure_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
